%global pkg sky2

%global kernel_version 4.18.0-305.19.1.el8_4

%global _use_internal_dependency_generator 0
%global __find_requires %{nil}
%global __find_provides /usr/lib/rpm/find-provides

%global debug_package %{nil}

%global __spec_install_post \
  %{?__debug_package:%{__debug_install_post}} \
  %{__arch_install_post} \
  %{__os_install_post} \
  %{__mod_compress_install_post}

%global __mod_compress_install_post find %{buildroot}/lib/modules -type f -name \*.ko -exec xz \{\} \\;


Name:             kmod-%{pkg}
Version:          5.8
Release:          5%{?dist}
Summary:          Marvell Yukon 2 Gigabit Ethernet (%{pkg}) driver

License:          GPLv2
URL:              https://www.kernel.org/

Source0:          %{pkg}-%{version}.tar.xz

ExclusiveArch:    x86_64 aarch64

BuildRequires:    elfutils-libelf-devel
BuildRequires:    gcc
BuildRequires:    kmod
BuildRequires:    make
BuildRequires:    redhat-rpm-config
BuildRequires:    xz

BuildRequires:    kernel-devel = %{kernel_version}
BuildRequires:    kernel-devel-uname-r = %{kernel_version}.%{_arch}

Requires:         kernel-core = %{kernel_version}
Requires:         kernel-core-uname-r = %{kernel_version}.%{_arch}
Requires:         kernel-modules = %{kernel_version}
Requires:         kernel-modules-uname-r = %{kernel_version}.%{_arch}

Provides:         installonlypkg(kernel-module)
Provides:         kernel-modules = %{kernel_version}.%{_arch}
Provides:         %{name}-%{kernel_version}.%{_arch} = %{?epoch:%{epoch}:}%{version}-%{release}

Requires(post):   /usr/sbin/depmod
Requires(postun): /usr/sbin/depmod

Requires(post):   /usr/bin/dracut
Requires(postun): /usr/bin/dracut


%description
This driver supports Gigabit Ethernet adapters based on the Marvell Yukon 2
chipset:

- 0x1148:0x9000: SysKonnect SK-9Sxx
- 0x1148:0x9E00: SysKonnect SK-9Exx
- 0x1148:0x9E01: SysKonnect SK-9E21M
- 0x1186:0x4001: D-Link DGE-550SX
- 0x1186:0x4B00: D-Link DGE-560T
- 0x1186:0x4B02: D-Link DGE-560SX
- 0x1186:0x4B03: D-Link DGE-550T
- 0x11AB:0x4340: Marvell 88E8021
- 0x11AB:0x4341: Marvell 88E8022
- 0x11AB:0x4342: Marvell 88E8061
- 0x11AB:0x4343: Marvell 88E8062
- 0x11AB:0x4344: Marvell 88E8021
- 0x11AB:0x4345: Marvell 88E8022
- 0x11AB:0x4346: Marvell 88E8061
- 0x11AB:0x4347: Marvell 88E8062
- 0x11AB:0x4350: Marvell 88E8035
- 0x11AB:0x4351: Marvell 88E8036
- 0x11AB:0x4352: Marvell 88E8038
- 0x11AB:0x4353: Marvell 88E8039
- 0x11AB:0x4354: Marvell 88E8040
- 0x11AB:0x4355: Marvell 88E8040T
- 0x11AB:0x4356: Marvell 88EC033
- 0x11AB:0x4357: Marvell 88E8042
- 0x11AB:0x435A: Marvell 88E8048
- 0x11AB:0x4360: Marvell 88E8052
- 0x11AB:0x4361: Marvell 88E8050
- 0x11AB:0x4362: Marvell 88E8053
- 0x11AB:0x4363: Marvell 88E8055
- 0x11AB:0x4364: Marvell 88E8056
- 0x11AB:0x4365: Marvell 88E8070
- 0x11AB:0x4366: Marvell 88EC036
- 0x11AB:0x4367: Marvell 88EC032
- 0x11AB:0x4368: Marvell 88EC034
- 0x11AB:0x4369: Marvell 88EC042
- 0x11AB:0x436A: Marvell 88E8058
- 0x11AB:0x436B: Marvell 88E8071
- 0x11AB:0x436C: Marvell 88E8072
- 0x11AB:0x436D: Marvell 88E8055
- 0x11AB:0x4370: Marvell 88E8075
- 0x11AB:0x4380: Marvell 88E8057
- 0x11AB:0x4381: Marvell 88E8059
- 0x11AB:0x4382: Marvell 88E8079


%prep
%autosetup -p1 -n %{pkg}-%{version}


%build
pushd src
%{__make} -C /usr/src/kernels/%{kernel_version}.%{_arch} %{?_smp_mflags} M=$PWD modules
popd


%install
%{__install} -D -t %{buildroot}/lib/modules/%{kernel_version}.%{_arch}/extra/drivers/net/ethernet/marvell src/%{pkg}.ko

# Make .ko objects temporarily executable for automatic stripping
find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+


%clean
%{__rm} -rf %{buildroot}


%post
mkdir -p %{_localstatedir}/lib/rpm-state/sig-kmods
touch %{_localstatedir}/lib/rpm-state/sig-kmods/%{kernel_version}.%{_arch}


%preun
mkdir -p %{_localstatedir}/lib/rpm-state/sig-kmods
touch %{_localstatedir}/lib/rpm-state/sig-kmods/%{kernel_version}.%{_arch}


%postun
if [ -f %{_localstatedir}/lib/rpm-state/sig-kmods/%{kernel_version}.%{_arch} ]
then
    if [ -f /lib/modules/%{kernel_version}.%{_arch}/System.map ]
    then
        /usr/sbin/depmod -aeF /lib/modules/%{kernel_version}.%{_arch}/System.map %{kernel_version}.%{_arch}
    fi

    if [ -f /boot/initramfs-%{kernel_version}.%{_arch}.img ]
    then
        if /usr/bin/dracut -f --rebuild /boot/initramfs-%{kernel_version}.%{_arch}.img /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew %{kernel_version}.%{_arch}
        then
            if ! cmp -s /boot/initramfs-%{kernel_version}.%{_arch}.img /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew
            then
                mv /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew /boot/initramfs-%{kernel_version}.%{_arch}.img
            else
                rm -f /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew
            fi
        fi
    fi

    rm -f %{_localstatedir}/lib/rpm-state/sig-kmods/%{kernel_version}.%{_arch}
    rmdir --ignore-fail-on-non-empty %{_localstatedir}/lib/rpm-state/sig-kmods
fi


%posttrans
if [ -f %{_localstatedir}/lib/rpm-state/sig-kmods/%{kernel_version}.%{_arch} ]
then
    if [ -f /lib/modules/%{kernel_version}.%{_arch}/System.map ]
    then
        /usr/sbin/depmod -aeF /lib/modules/%{kernel_version}.%{_arch}/System.map %{kernel_version}.%{_arch}
    fi

    if [ -f /boot/initramfs-%{kernel_version}.%{_arch}.img ]
    then
        if /usr/bin/dracut -f --rebuild /boot/initramfs-%{kernel_version}.%{_arch}.img /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew %{kernel_version}.%{_arch}
        then
            if ! cmp -s /boot/initramfs-%{kernel_version}.%{_arch}.img /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew
            then
                mv /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew /boot/initramfs-%{kernel_version}.%{_arch}.img
            else
                rm -f /boot/initramfs-%{kernel_version}.%{_arch}.img.rpmnew
            fi
        fi
    fi

    rm -f %{_localstatedir}/lib/rpm-state/sig-kmods/%{kernel_version}.%{_arch}
    rmdir --ignore-fail-on-non-empty %{_localstatedir}/lib/rpm-state/sig-kmods
fi


%files
%defattr(644,root,root,755)
/lib/modules/%{kernel_version}.%{_arch}
%license COPYING


%changelog
* Wed Sep 15 2021 Peter Georg <peter.georg@physik.uni-regensburg.de> - 5.8-5
- Rebuild for 4.18.0-305.19.1.el8_4

* Thu Sep  9 2021 Peter Georg <peter.georg@physik.uni-regensburg.de> - 5.8-4
- Set specific kernel version to use
- Add Provides kernel-modules
- Add .%{_arch} to kernel-modules provides version
- Rebuild for 4.18.0-305.17.1.el8_4

* Wed Aug 11 2021 Peter Georg <peter.georg@physik.uni-regensburg.de> - 5.8-3
- Rebuild for 4.18.0-305.12.1.el8_4

* Wed Aug 11 2021 Peter Georg <peter.georg@physik.uni-regensburg.de> - 5.8-2
- Initial version
